import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * https://static.pexels.com/photos/110854/pexels-photo-110854.jpeg 
 * 

 */
public class Space extends World
{
    private int score;
    private int time = 2000;
    private int energy = 100;
    public int points;
    private int wall = 200;
    public boolean deployShield;
    //count down of the BigShield when the BigShield appears in the scenario - using 
    // the wall int
    
    /**
     * Constructor: Set up the staring objects.
     */
    public Space()
    {    
        super(1080, 720, 1); 
        setPaintOrder(Telescope.class);
        prepare();
        addScore(+ points);
        showTime();
        time = 2000;
        showEnergy();
        energy = 100;
        //wallTimer();
        showwall();
        boolean deployShield = true;
    }
    
        public void wallTimer()
    {
        wall--;
        if (wall == 0)
        {
            
        }
    }
    
    public void showwall()
    {
        showText("Shield: " + wall, 700, 80);
    }

    public void addScore(int points)
    {
        score = score + points;
        showText("Score:" + score, 80 , 25);
        if (score < 0)
        {
            Greenfoot.playSound("Explosion.wav");
            Greenfoot.stop();
        }
    }

    /**
     * Create new floating objects at irregular intervals.
     */
    public void act()
    {
        if (Greenfoot.getRandomNumber(100) < 3)
        {
            addObject(new BlackAsteroid(), 1080, Greenfoot.getRandomNumber(720));
            //BlackAsteroid
        }
        if (Greenfoot.getRandomNumber(100) < 1)
        {
            addObject(new Asteroid(), 1080, Greenfoot.getRandomNumber(720));
            //Asteroid
        }
        if (Greenfoot.getRandomNumber(100) < 2)
        {
            addObject(new Belt(), 1080, 40);
            //topBelt
        }
        if (Greenfoot.getRandomNumber(100) < 2)
        {
            addObject(new Belt(), 1080, 680);
            //bottomBelt
        }
        countTime();
        deploy();
    }

    public void deploy()
    {
        if (Greenfoot.isKeyDown("e")) 
            countEnergy();
    }
    
    private void countEnergy()
    {
        energy--;
        showEnergy();
        if (energy == 0)
        {
            deployShield = false;
        }
    }

    private void showEnergy()
    {
        showText("Energy: " + energy, 700, 50);
    }
    
    private void countTime()
    {
        time--;
        showTime();
        if (time == 0)
        {
            showEndMessage();
            Greenfoot.stop();
            Greenfoot.playSound("win.wav");
        }
    }

    private void showTime()
    {
        showText("Time: " + time, 700, 25);
    }
    
    private void showEndMessage()
    {
        showText ("Time is up - you win!", 540, 360);
        showText("Your final score: " + score + " points", 540, 340);
    }

    /**
     * Prepare the world for the start of the program. In this case: Create
     * a white blood cell and the Belt at the edge of the blood stream.
     */
    private void prepare()
    {
        SpaceShip spaceship = new SpaceShip();
        addObject(spaceship,125,376);
        Telescope telescope = new Telescope();
        addObject(telescope,5,371);
        Telescope telescope2 = new Telescope();
        addObject(telescope2,1063,366);
        Belt belt = new Belt();
        addObject(belt,1014,698);
        Belt belt2 = new Belt();
        addObject(belt2,880,703);
        Belt belt3 = new Belt();
        addObject(belt3,762,709);
        Belt belt4 = new Belt();
        addObject(belt4,636,711);
        Belt belt5 = new Belt();
        addObject(belt5,530,711);
        Belt belt6 = new Belt();
        addObject(belt6,406,711);
        Belt belt7 = new Belt();
        addObject(belt7,317,712);
        Belt belt8 = new Belt();
        addObject(belt8,216,712);
        Belt belt9 = new Belt();
        addObject(belt9,97,711);
        Belt belt10 = new Belt();
        addObject(belt10,38,712);
        Belt belt11 = new Belt();
        addObject(belt11,1045,36);
        Belt belt12 = new Belt();
        addObject(belt12,922,40);
        Belt belt13 = new Belt();
        addObject(belt13,799,40);
        Belt belt14 = new Belt();
        addObject(belt14,678,41);
        Belt belt15 = new Belt();
        addObject(belt15,556,41);
        Belt belt16 = new Belt();
        addObject(belt16,409,45);
        Belt belt17 = new Belt();
        addObject(belt17,271,36);
        Belt belt18 = new Belt();
        addObject(belt18,180,44);
        Belt belt19 = new Belt();
        addObject(belt19,105,45);
        Belt belt20 = new Belt();
        addObject(belt20,613,42);
        Belt belt21 = new Belt();
        addObject(belt21,707,714);
        Belt belt22 = new Belt();
        addObject(belt22,464,718);
        PowerUp powerup = new PowerUp();
        addObject(powerup,1017,358);
    }
}
